/*

Rue_mohr s brainfuck interperter.
AVR Version Feb 18 2013
V3.0000000000000000000000000000000 

This is <!--linux-only--> AVR-only software. 


brainfuck
>  ptr++
<  ptr--
+ (*ptr)++
- ((ptr)--
. printf(*ptr)
, *ptr = getchar()
[ if the byte at the data pointer is zero, then instead of moving the instruction pointer forward to the next command, jump it forward to the command after the matching ] 
] if the byte at the data pointer is nonzero, then instead of moving the instruction pointer forward to the next command, jump it back to the command after the matching [ command

** tape limited to 256 bytes
** program limit 1022 bytes (yes 1022, must begin and end with '0')
** this is taylored for an atmega32, via avrisp2 programmer


Title:    i2c eeprom test code
Author:   rue_mohr
Date:     Feb 15 2013
Software: AVR-GCC 3.3 
Hardware: atmega32
  

                 
+-------------------------------------+
 |                          Sig Vd Gnd |
 |  +---------+   5V O     PB0 [o o o] | Input
 |  | 7805  O |   Vd O     PB1 [o o o] | Input
 |  +---------+   V+ .     PB2 [o o o] | Input
 |                         PB3 [o o o] | Input
 |                         PB4 [o o o] | Input
 |                         PB5 [o o o] | Input
 |                         PB6 [o o o] | Input
 |                         PB7 [o o o] | Input
 |                         PA0 [o o o] | Output
 |                         PA1 [o o o] | Output
 |        +----------+     PA2 [o o o] | Output
 |        |O         |     PA3 [o o o] | Output
 |        |          |     PA4 [o o o] | Output
 |        |          |     PA5 [o o o] | Output
 |        |          |     PA6 [o o o] | Output
 |        |          |     PA7 [o o o] | Output
 |        |          |     PC7 [o o o] |
 |        |          |     PC6 [o o o] |
 |        |          |     PC5 [o o o] |
 |        | ATMEGA32 |     PC4 [o o o] |
 |        |          |     PC3 [o o o] |
 |        |          |     PC2 [o o o] | Status 2
 |        |          |     PC1 [o o o] | Status 1
 |        |          |     PC0 [o o o] | Status 0  
 |        |          |     PD7 [o o o] | 
 |        |          |     PD2 [o o o] | 
 |        |          |     PD3 [o o o] | 
 |        |          |     PD4 [o o o] |
 |        |          |     PD5 [o o o] |
 |        +----------+     PD6 [o o o] |
 |      E.D.S BABYBOARD III            |
 +-------------------------------------+

 this config line has nothing to do with anything

/usr/local/bin/avrdude -c stk500v2 -p m8 -P /dev/ttyACM0 -e -B8 -U flash:w:main.hex -U eeprom:w:main_eeprom.hex
   
avrdude -U eeprom:w:main.bf:r
but main.bf needs to start and end with '/0'  hmmmm   
    
COMPILE
> make clean
> make

INSTALL FIRMWARE
> make usbinstall
    
INSTALL BF ... FIRMWARE?
> avrdude -c avrisp2 -P usb -p atmega32 -U eeprom:w:bfmain.raw:r   

    
No function shall be longer than 1 screen (readable font size (NO MICROSCOPES!))    
*/
/****************************| INCLUDGEABLES |********************************/
 
#include<avr/io.h>
#include <avr/eeprom.h> 


/************************| FUNCTION DECLARATIONS |*************************/


void          run(void);
unsigned int  srchfwd(unsigned int iptr) ;
unsigned int  srchbck(unsigned int iptr); 
void          Output(unsigned char c);
unsigned char Input(void);
unsigned char GetProg(unsigned int a);

/*****************************| DEFINIATIONS |********************************/

#define OUTPUT             1
#define INPUT              0

// people use stuff like this to say I dont know how to code, but also say using goto is ok in C (?!?!??!?!)

#define IsHigh(BIT, PORT)    ((PORT & (1<<BIT)) != 0)
#define IsLow(BIT, PORT)     ((PORT & (1<<BIT)) == 0)
#define SetBit(BIT, PORT)     PORT |= (1<<BIT)
#define ClearBit(BIT, PORT)   PORT &= ~(1<<BIT)

// everything ok (running)
#define STATUS_OK()           PORTC = 0x01
// missing left backet (halted)
#define STATUS_MRSLEFT()      PORTC = 0x02
// missing right backet (halted)
#define STATUS_MRSRITE()      PORTC = 0x04
// program stopped
#define STATUS_STOP()         PORTC = 0x05

//#define Output(d)  printf("%c", d)
//#define Input()    getchar();
/*
char  progbuff[1024];
#define GetProg(a) progbuff[a]
*/


 

/***********************| GLOBULEBLE VARIADABLES |********************************/

// NIN VARIADABLE GLOBULES!

/****************************| CODE... |***********************************/


/*
   This could use compressed data for storing the program
   BUT I WOULDN'T WANT A PERFORMANCE HIT LIKE THAT WOULD I!!!!!!
   HAHAHAHAHHAHAHAHAhahahahah....
*/
unsigned char GetProg(unsigned int a) {
  return eeprom_read_byte((uint8_t*)a); 
}

/* It might be nice to toggle a pin to say that we have new output on the port.
   a person could also make this output to a serial port.
*/
void Output(unsigned char c) {
  PORTA = c;
}

/* It might be nice for it to wait for a pulse so you know the data on the pins is
   new, fresh, valid data, a person could even wait and use a char from the serial port.
*/
unsigned char Input(void) {
  return PINB;
}


// search forward for a matching ]
unsigned int srchfwd(unsigned int iptr) { // were pointing to a [
   
  unsigned int level = 0;
  
  while(GetProg(iptr)) {
    iptr++;
    switch(GetProg(iptr)) {
    
      case '[':
        level++;
      break;
      
      case ']':
        if (!level) return iptr; // 1 will be added by the main loop
        else level--;
      break;
        
    }  
  }
  
  return 0; // 0 is null, aka error

}



unsigned int srchbck(unsigned int iptr) { // were pointing to a ]
   
  unsigned int level = 0;
  
  while(GetProg(iptr)) {
    iptr--;
    switch(GetProg(iptr)) {
          
      case '[':
        if (!level) return iptr;// 1 will be added by the main loop
        else level--;        
      break;
      
      case ']':
        level++;
      break;
        
    }  
  }
  
   return 0;

}


void run(void) {

  char data[256];
  unsigned int iptr, dptr;  
      
  for (dptr = 0; dptr<255; dptr++)  data[dptr] = 0;     
  
  iptr  = 1; // init program.
  dptr  = 0; // init memory
  
  while(GetProg(iptr)) {  
    switch(GetProg(iptr)) {
      case '+':  // increment value at data pointer
        data[dptr]++;
      break;    
    
      case '-':  // comments are for woos'
        data[dptr]--;
      break;  
      
      case '>':  // increment data pointer
        if (dptr < 255) dptr++;
      break;
      
      case '<':  // comments are for woos'
         if(dptr > 0)   dptr--;
      break;
      
      case '.':  // output the data at the pointer
         Output(data[dptr]); 
      break;
      
      case ',':  // did you READ the BF instruction set?
         data[dptr] = Input();
      break;
      
      case '[':  // its complex, see manual.
        if (!(data[dptr])) { // jump to matching ]
           iptr = srchfwd(iptr);
           if (!iptr) {
             STATUS_MRSRITE();
             while(1);
           }
        }
      break;
      
      case ']': // opposite of above, but different
         if (data[dptr]) { // jump to matching [
           iptr = srchbck(iptr);
           if (!iptr) {
             STATUS_MRSLEFT();
             while(1);
           }
         }
      break;
          
    }
    
    iptr++;
    // if your going to put a delay to slow down the program execution, THIS is the spot
    // no wait, HERE is better
    // or HERE    
  }  // NOT here.
}
 // DEFINITLY NOT HERE


int main(void) {
  
  DDRA = (OUTPUT << PA0 | OUTPUT << PA1 |OUTPUT << PA2 |OUTPUT << PA3 |OUTPUT << PA4 |OUTPUT << PA5 |OUTPUT << PA6 |OUTPUT << PA7);
  DDRB = (INPUT << PB0 | INPUT << PB1 |INPUT << PB2 |INPUT << PB3 |INPUT << PB4 |INPUT << PB5 |INPUT << PB6 |INPUT << PB7);
  DDRC = (OUTPUT << PC0 | OUTPUT << PC1 |OUTPUT << PC2 |INPUT << PC3 |INPUT << PC4 |INPUT << PC5 |INPUT << PC6 |INPUT << PC7);
  DDRD = (INPUT << PD0 | INPUT << PD1 |INPUT << PD2 |INPUT << PD3 |INPUT << PD4 |INPUT << PD5 |INPUT << PD6 |INPUT << PD7);        
  
  STATUS_OK();   
  run();
  
  STATUS_STOP();  
  while(1);
  
  return 0;
}
