#include <stdio.h>  // fopen fclose printf

int copy(FILE *copyin, FILE *copyout);
int padcopy(FILE *copyin, FILE *copyout);

main(int argc, char* argv[]) {  // access command-line arguments

 FILE *IN, *OUT;

 if (argc<3){
   printf("useage: %s source dest", argv[0]);
   return(-1);
 }

 if ((IN = fopen(argv[1], "rb"))== NULL) {
   printf("unable to open %s for input", argv[1]);
   return(-2);
 }

 if ((OUT = fopen(argv[2], "w+b"))== NULL) {
   printf("unable to open %s for output", argv[2]);
   fclose(IN);
   return(-3);
 }

 if (padcopy(IN, OUT) != 0) {
   printf ("Error occured while copying, is your drive full?");
   fclose(IN);
   fclose(OUT);
   return(-4);
 }
 
 fclose(IN);
 fclose(OUT);
 return 0;

}


int padcopy(FILE *copyin, FILE *copyout) {

  char zero;
  zero = 0; ///OOOOoooo
 
  if (fwrite(&zero, 1, 1, copyout) != 1)      return -1;
  if (copy(copyin, copyout) != 0) return -1;
  if (fwrite(&zero, 1, 1, copyout) != 1)      return -1;
  return 0;
}


int copy(FILE *copyin, FILE *copyout) {
  char   fbuff[32768];  //temp file buffer
  char   working;  // number of chunks to copy file with
  unsigned long readsize;

  //reset file pointer
  fseek(copyin, 0, SEEK_SET);

  working=1;

  while(working) {
    if ((readsize=fread(fbuff, 1, 32760, copyin)) != 32760)   working = 0; // read a buffer
    if ((fwrite(fbuff, 1, readsize, copyout)) != readsize)   return(-1);  // write a buffer
  }
   
  return 0;
}


